#pragma once

#include "Reversi.h"

class CGameReversi : public CReversi
{
public:
	// Player
	enum {
		ePlayer_MAN, 
		ePlayer_COM1,
		ePlayer_COM2, 
		ePlayer_COM3, 
		ePlayer_COM4, 
		ePlayer_COM5,
	};

private:
	int m_nBoardValue[8][8];	//! Ֆʕ]l
	int m_nBoardDecision[8][8];	//! Ֆʊmx
	int m_nProcess[60][3];		//! 菇
	int m_nProcessPos;			//! ̎萔
	int m_nCurrentOrder;        //! ݂̎菇
	int m_nFirstPlayer;			//! ŨvC[
	int m_nLastPlayer;			//! ŨvC[
	BOOL m_bGuide;				//!	KCh\̃tO

	CDC			m_FirstPieceDc;			//! 
	CBitmap		m_FirstPieceBmp;		//! 
	CDC			m_LastPieceDc;			//! 
	CBitmap		m_LastPieceBmp;			//! 

public:
	CGameReversi();
	virtual ~CGameReversi();

protected:
	// f[^̊֐
	void DataInitialize();
	// ̊G̍XV
	void RefreshPieceDc();

protected:
	// lԂ
	BOOL PutPiece(int nOrder, int x, int y);                   
	// Rs[^
	BOOL PutPieceAuto();
	// ł̏ōs
	void PutPieceAfter();
	
protected:
	// ~`悷    
	void PaintCircle(CDC* pDC,CRect* lpRect,COLORREF pen,COLORREF brush);
	// Ֆʕ`
	void DrawBoard(CDC* pDC);
	// KCh`
	void DrawGuide(CDC* pDC, int nOrder);

protected:
	// ǂݏ
	void ThinkNext(int num_next, int color, int* x, int* y);
	// -T
	int AlphaBeta(int height, int current_height, int color, int alpha, int beta);
	// ]lvZ	
	int GetValue(int nOrder);

public:
	// Q[Jn
	void StartGame();
	// Q[Iǂ𔻒肷
	BOOL IsGameSet();
	// ̎Rs[^
	BOOL NextByComputer();
	// NbNŋu
	BOOL MouseClick(const CPoint& point);
	// Ֆʂ̕`
	void Draw(CDC* pDC);

public:
	// ʃf[^ݒ
	void SetBoardRect(CRect* lpRect);

public:
	// KCh\邩ǂ
	void SetGuideView(BOOL bGuide) { m_bGuide = bGuide; }

	// vC[̐ݒ
	void SetPlayer(int first, int last){
		m_nFirstPlayer = first;			//! ŨvC[
		m_nLastPlayer  = last;			//! ŨvC[
	}
	// vC[̎擾
	int GetPlayer(int nOrder) { 
		return !nOrder ? m_nFirstPlayer : m_nLastPlayer;
	}

public:
	// ݂̎菇̎擾
	int GetCurrentOrder() { return m_nCurrentOrder; }
	// ݉ڂ擾
	int GetProcessCount() { return m_nProcessPos; }
	// Ō̎擾
	void GetLastProcess(int* nOrder, int* x, int* y) {
		if ( m_nProcessPos > 0 ) {
			int nPos = m_nProcessPos -1;
			*nOrder = m_nProcess[nPos][0];
			*x		= m_nProcess[nPos][1];
			*y		= m_nProcess[nPos][2];
		}
	}
	// w̎擾
	void GetLastProcess(int nPos,int* nOrder, int* x, int* y) {
		if ( nPos >=0 && nPos < m_nProcessPos ) {
			*nOrder = m_nProcess[nPos][0];
			*x		= m_nProcess[nPos][1];
			*y		= m_nProcess[nPos][2];
		}
	}
};


