// Reversi.cpp: CReversi NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Reversi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CReversi::CReversi()
{
	// J[ݒiftHgj
	m_FirstPieceColor	= RGB(255,255,255);		//! s̋F
	m_LastPieceColor	= RGB(0,0,100);			//! ŰF
	m_BorderColor		= RGB(0,0,0);			//! g̐F
	m_BgColor			= RGB(180,180,180);//RGB(50,150,50);		//! wi̐F
	m_TextColor			= RGB(0,0,0);			//! ̐F

	// f[^
	DataInitialize();

	CRect rc(0,0,420,420);
	m_PaddingRect.SetRect(4,4,4,4);
	SetBoardRect(&rc);
}

CReversi::~CReversi()
{

}

//protected:
// ~`悷    
/*virtual*/ void CReversi::PaintCircle(CDC* pDC,CRect* lpRect,COLORREF PenColor,COLORREF BrushColor)
{
	CPen pen(PS_SOLID,2,PenColor);
	CBrush brush(BrushColor);
	CPen* oldPen=pDC->SelectObject(&pen);
	CBrush* oldBrush=pDC->SelectObject(&brush);

	// `悷
	pDC->Ellipse(lpRect);

	// yƃuV߂
	pDC->SelectObject(oldPen);
	pDC->SelectObject(oldBrush);
}

// 𗠕Ԃ֐
/*virtual*/ int CReversi::ReversePiece(int x,int y,int nOrder,BOOL bCheckOnly)
{
	// `FbN
	if ( !(nOrder == eOrder_FIRST || nOrder == eOrder_LAST) || (x < 0 || x > 7) || (y < 0 || y > 7) ) {
		ASSERT(FALSE);
		TRACE(_T("֐ReverseŕsȐF̎w肩ՊÕf[^ɃANZX悤Ƃ܂\n"));
		return 0;
	}

	// u}X󂢂ĂȂȂ
	if ( m_nBoard[x][y] != eOrder_EMPTY ) {
		return 0;
	}

	int i,j;
	int nRevCount = 0;	// Ԃ鐔
	int nRevOrder = !nOrder;

	i=x+1; j=y;
	// Ẽ`FbN
	if ( i <= 6 && m_nBoard[i][j] == nRevOrder ) {
		i++;
		while(i <= 7 && m_nBoard[i][j] == nRevOrder) { i++; }
		if (i <= 7 && m_nBoard[i][j] == nOrder ) {
			nRevCount += i-x-1;
			if ( !bCheckOnly ) {
				i=x+1; j=y;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i++;
				}
			}
		}
	}
	i=x-1; j=y;
	// ̃`FbN
	if ( i >= 1 && m_nBoard[i][j] == nRevOrder ) {
		i--;
		while ( i >= 0 && m_nBoard[i][j] == nRevOrder ) { i--; }
		if (i >= 0 && m_nBoard[i][j] == nOrder ) {
			nRevCount += x-i-1;
			if ( !bCheckOnly ) {
				i=x-1; j=y;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i--;
				}
			}
		}
	}
	i=x; j=y+1;
	// ̃`FbN
	if (j <= 6 && m_nBoard[i][j] == nRevOrder ) {
		j++;
		while ( j <= 7 && m_nBoard[i][j] == nRevOrder ) { j++; }
		if ( j <= 7 && m_nBoard[i][j] == nOrder ) {
			nRevCount += j-y-1;
			if ( !bCheckOnly ) {
				i=x; j=y+1;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					j++;
				}
			}
		}
	}
	i=x; j=y-1;
	// ̃`FbN
	if ( j >= 1 && m_nBoard[i][j] == nRevOrder ) {
		j--;
		while ( j >= 0 && m_nBoard[i][j] == nRevOrder ) { j--; }
		if ( j >= 0 && m_nBoard[i][j] == nOrder ) {
			nRevCount += y-j-1;
			if ( !bCheckOnly ) {
				i=x; j=y-1;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					j--;
				}
			}
		}
	}
	i=x+1; j=y-1;
	// Ẽ`FbN
	if (i <= 6 && j >= 1 && m_nBoard[i][j] == nRevOrder ) {
		i++; j--;
		while (i <= 7 && j >= 0 && m_nBoard[i][j] == nRevOrder ) { i++; j--; }
		if (i <= 7 && j >= 0 && m_nBoard[i][j] == nOrder ) {
			nRevCount += i-x-1;
			if ( !bCheckOnly ) {
				i=x+1; j=y-1;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i++; j--;
				}
			}
		}
	}
	i=x-1; j=y-1;
	// ̃`FbN
	if (i >= 1 && j >= 1 && m_nBoard[i][j] == nRevOrder ) {
		i--; j--;
		while ( i >= 0 && j >= 0 && m_nBoard[i][j] == nRevOrder ) { i--; j--; }
		if (i >= 0 && j >= 0 && m_nBoard[i][j] == nOrder ) {
			nRevCount += x-i-1;
			if ( !bCheckOnly ) {
				i=x-1; j=y-1;
				while( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i--; j--;
				}
			}
		}
	}
	i=x+1; j=y+1;
	// Ẽ`FbN
	if (i <= 6 && j <= 6 && m_nBoard[i][j] == nRevOrder ) {
		i++; j++;
		while ( i <= 7 && j <= 7 && m_nBoard[i][j] == nRevOrder ) { i++; j++; }
		if ( i <= 7 && j <= 7 && m_nBoard[i][j] == nOrder ) {
			nRevCount += i-x-1;
			if ( !bCheckOnly ) {
				i=x+1; j=y+1;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i++; j++;
				}
			}
		}
	}
	i=x-1; j=y+1;
	// ̃`FbN
	if (i >= 1 && j <= 6 && m_nBoard[i][j] == nRevOrder ) {
		i--; j++;
		while ( i >= 0 && j <= 7 && m_nBoard[i][j] == nRevOrder ) { i--; j++; }
		if ( i >= 0 && j <= 7 && m_nBoard[i][j] == nOrder ) {
			nRevCount += x-i-1;
			if ( !bCheckOnly ) {
				i=x-1; j=y+1;
				while ( m_nBoard[i][j] == nRevOrder ) {
					m_nBoard[i][j] = nOrder;	// Ԃ
					i--; j++;
				}
			}
		}
	}

	if ( !bCheckOnly && nRevCount ) {
		m_nBoard[x][y] = nOrder;
	}

	// Ԃ鐔Ԃ
	return nRevCount;
}

// w肳ꂽʒuw肳ꂽFɂ
/*virtual*/ void CReversi::SetPieceColor(int x, int y, int nOrder)
{
	// `FbN
	if( (nOrder == eOrder_FIRST || nOrder == eOrder_LAST || nOrder == eOrder_EMPTY) && (x >= 0 && x < 8) && (y >= 0 && y < 8) ) {
		m_nBoard[x][y] = nOrder;
	} else {
		ASSERT(FALSE);
	}
}

//public:
// f[^̊֐
/*virtual*/ void CReversi::DataInitialize()
{
	int x, y;

	// Ֆʂ̃}Xɂ
	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			m_nBoard[x][y] = eOrder_EMPTY;
		}
	}

	// ^̋ݒ
	m_nBoard[3][3] = m_nBoard[4][4] = eOrder_FIRST;
	m_nBoard[3][4] = m_nBoard[4][3] = eOrder_LAST;
}

// Օ`
/*virtual*/ void CReversi::DrawBoard(CDC* pDC)
{
	// wi̕`
	pDC->FillSolidRect( &m_BoardRect, m_BgColor );

	// Ղ̕`iځj
	CPen BorderPen( PS_SOLID, 1, m_BorderColor );
	CPen* oldPen = pDC->SelectObject( &BorderPen );

	int nBasex = m_BoardRect.left + m_PaddingRect.left;
	int nBasey = m_BoardRect.top + m_PaddingRect.top;

	int x, y;
	for( x=0,y=0; x<=8; x++,y++ ) {
		pDC->MoveTo( nBasex+x*m_nMassWidth,	nBasey );
		pDC->LineTo( nBasex+x*m_nMassWidth,	nBasey+m_nMassHeight*8 );
		pDC->MoveTo( nBasex,				nBasey+x*m_nMassHeight );
		pDC->LineTo( nBasex+m_nMassWidth*8,	nBasey+x*m_nMassHeight );
	}

	// Õyɖ߂
	pDC->SelectObject( oldPen );
}

// ̕`̊֐
/*virtual*/ void CReversi::DrawPiece(CDC* pDC)
{
	int x,y;
	int left, top, right, bottom;
	int nOrder;

	CRect rect;
	int nBasex = m_BoardRect.left + m_PaddingRect.left;
	int nBasey = m_BoardRect.top + m_PaddingRect.top;

	// }XS`FbN
	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			// UHUH
			nOrder = m_nBoard[x][y];

			// ~GAݒ
			left   = int(nBasex + x*m_nMassWidth + m_nMassWidth/10);
			top    = int(nBasey + y*m_nMassHeight + m_nMassHeight/10);
			right  = int(nBasex + (x+1)*m_nMassWidth - m_nMassWidth/10);
			bottom = int(nBasey + (y+1)*m_nMassHeight - m_nMassHeight/10);
			rect.SetRect(left, top, right, bottom);

			// ̐Fɂ~`
			if ( !nOrder ) {
				PaintCircle( pDC, &rect, RGB(0,0,0), m_FirstPieceColor );
			} else if ( nOrder == eOrder_LAST ) {
				PaintCircle( pDC, &rect, RGB(0,0,0), m_LastPieceColor );
			}
		}
	}
}
	
// 
//public:
// w肳ꂽF̋uꏊ邩
/*virtual*/ BOOL CReversi::IsCanPut(int nOrder)
{
	int x,y;

	// uꏊ𒲂ׂ
	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			if ( m_nBoard[x][y] == eOrder_EMPTY && ReversePiece( x, y, nOrder, TRUE ) ) return TRUE;
		}
	}
	return FALSE;
}

// u
/*virtual*/ BOOL CReversi::PutPiece(int nOrder, int x, int y)
{
	// `FbN
	if ( !(nOrder == eOrder_FIRST || nOrder == eOrder_LAST) || ( (x < 0 || x > 7) || (y < 0 || y > 7) ) ) {
		//ASSERT(FALSE);
		return FALSE;
	}

	// ̃}X󂢂ĂĒu邩
	if ( m_nBoard[x][y] == eOrder_EMPTY && ReversePiece( x, y, nOrder, FALSE ) ) {
		return TRUE;
	}
	else return FALSE;
}

// ŋu
/*virtual*/ BOOL CReversi::PutPieceAuto(int nLevel, int nOrder)
{
	// `FbN
	if ( !(nOrder == eOrder_FIRST || nOrder == eOrder_LAST) ) {
		ASSERT(FALSE);
		return FALSE;
	}

	static int nNextList[64][2];
	int nNextListCount = 0;	//! ̎̐

	int x, y;
	int nPos = 0;			//! YǗ

	switch ( nLevel ) {
	case 1:
		{
			// x1i_ɑłj
			// u}X̐𐔂
			for ( y=0; y<8; y++ ) {
				for ( x=0; x<8; x++ ) {
					if ( m_nBoard[x][y] == eOrder_EMPTY && ReversePiece( x, y, nOrder, TRUE ) > 0) {
						nNextList[nNextListCount][0] = x;
						nNextList[nNextListCount++][1] = y;
					}
				}
			}

			// uꏊȂȂI
			if ( nNextListCount == 0 ) return FALSE;
		}
		break;
	
	case 2:
		{
			int nRevCount = 0;		//! Ԃ鐔
			int nRevCountMax = 0;	//! ő̗Ԃ鐔

			// x2i1ԗԂ̂Tj
			// 1ԗԂ}X̐𐔂
			for ( y=0; y<8; y++ ) { 
				for ( x=0; x<8; x++ ) {
					if ( m_nBoard[x][y] == eOrder_EMPTY ) {
						// Ԃ鐔vZ
						if ( nRevCount = ReversePiece( x, y, nOrder, TRUE ) ) {
							// ܂ł̍ō
							if( nRevCount > nRevCountMax ){
								nNextListCount = 0;
								nNextList[nNextListCount][0] = x;
								nNextList[nNextListCount++][1] = y;
							}
							else if ( nRevCount == nRevCountMax ) {
								nNextList[nNextListCount][0] = x;
								nNextList[nNextListCount++][1] = y;
							}
						}
					}
				}
			}

			// uꏊȂȂI
			if ( !nNextListCount ) {
				return FALSE;
			}
		}
		break;
	}

	// Xg̒I
	nPos = rand()%nNextListCount;
	x = nNextList[nPos][0];
	y = nNextList[nPos][1];

	return PutPiece( x, y, nOrder );
}

// w肳ꂽF̋̐Ԃ֐
/*virtual*/ int CReversi::GetPieceCount(int nOrder)
{
	int x,y;
	int nCount = 0;

	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			if ( m_nBoard[x][y] == nOrder ) nCount++;
		}
	}

	return nCount;
}

// w肳ꂽʒűUU擾
/*virtual*/ int CReversi::GetOrderOnPiece(int x,int y)
{
	if (  (x < 0 || x > 7) || (y < 0 || y > 7) ) {
		ASSERT(FALSE);
		return eOrder_EMPTY;
	}
	return m_nBoard[x][y];
}

// ʃf[^ݒ
/*virtual*/ void CReversi::SetBoardRect(CRect* lpRect)
{
	m_BoardRect = *lpRect;

	m_nMassWidth	= (m_BoardRect.Width()-m_PaddingRect.left-m_PaddingRect.right)/8;
	m_nMassHeight	= (m_BoardRect.Height()-m_PaddingRect.top-m_PaddingRect.bottom)/8;
}